/*
 * rizeni.c
 *
 *  Created on: 1. 5. 2021
 *      Author: tomas
 */

#include "rizeni.h"

ePodvozky zvoleny;

ePodvozky MotorsInit(ePodvozky podvozek)
{
  SystemCoreClockUpdate();
  uint32_t apb1 = GetBusClock(busClockAPB1);
  zvoleny = podvozek;
  switch(podvozek)
  {
    case zumo:
      Nucleo_SetPinGPIO(ZUMO_M2DIR, ioPortOutputPP);          //pin DIR jako vystup
      Nucleo_SetPinGPIO(ZUMO_M1DIR, ioPortOutputPP);          //pin DIR jako vystup
      Nucleo_SetPinGPIO(ZUMO_BUTTON,ioPortInputPU);
      // PRAVY MOTOR M1
      if(!(RCC->APB1ENR & RCC_APB1ENR_TIM3EN))                //test hodin
      {
        RCC->APB1ENR |= RCC_APB1ENR_TIM3EN;
        RCC->APB1RSTR |= RCC_APB1RSTR_TIM3RST;
        RCC->APB1RSTR &= ~RCC_APB1RSTR_TIM3RST;
      }
      TIM3->CR1 = 0;                      //DIR = 0 - up counter
      TIM3->CR2 = 0;                      //zadne dalsi spec funkce
      TIM3->PSC = (apb1/2040816) - 1;       // cca 2 MHz
      TIM3->ARR = 256 - 1;                // 8khz
      TIM3->CR1 = TIM_CR1_CEN;            // povoleni casovace
      Nucleo_SetPinGPIO(ZUMO_M1PWM, ioPortAlternatePP);
      Nucleo_SetAFGPIO(ZUMO_M1PWM, 2);      //AF02 odpovida TIM3_CH2
      TIM3->CCMR1 &= ~TIM_CCMR1_OC2CE;
      TIM3->CCMR1 |= TIM_CCMR1_OC2M_2 | TIM_CCMR1_OC2M_1;      //110 - PWM mode 1
      TIM3->CCER |= TIM_CCER_CC2E;        //povoleni channel 2
      TIM3->CCR2 = 0;                     //strida
      // LEVY MOTOR M2
      if(!(RCC->APB1ENR & RCC_APB1ENR_TIM4EN))            //test hodin
      {
        RCC->APB1ENR |= RCC_APB1ENR_TIM4EN;
        RCC->APB1RSTR |= RCC_APB1RSTR_TIM4RST;
        RCC->APB1RSTR &= ~RCC_APB1RSTR_TIM4RST;
      }
      TIM4->CR1 = 0;                    //DIR = 0 - up counter
      TIM4->CR2 = 0;                  //zadne dalsi spec funkce
      TIM4->PSC = (apb1/2040816) - 1;   //2 MHz
      TIM4->ARR = 256 - 1;            //cca 8khz
      TIM4->CR1 = TIM_CR1_CEN;        //povoleni casovace
      Nucleo_SetPinGPIO(ZUMO_M2PWM, ioPortAlternatePP);
      Nucleo_SetAFGPIO(ZUMO_M2PWM, 2);   //AF02 odpovida TIM4_CH1
      TIM4->CCMR1 &= ~TIM_CCMR1_OC1CE;
      TIM4->CCMR1 |= TIM_CCMR1_OC1M_2 | TIM_CCMR1_OC1M_1;      //110 - PWM mode 1
      TIM4->CCER |= TIM_CCER_CC1E;    //povoleni channel 1
      TIM4->CCR1 = 0;                 //strida
      break;

    case lego:
      Nucleo_SetPinGPIO(DRIVER_ENA,ioPortOutputPP);   //EN jako vystup
      Nucleo_SetPinGPIO(DRIVER_ENB,ioPortOutputPP);   //EN jako vystup
      GPIOWrite(DRIVER_ENA,true);                     //povoleni motoru A
      GPIOWrite(DRIVER_ENB,true);                     //povoleni motoru B
      //PRAVY MOTOR A
      if(!(RCC->APB1ENR & RCC_APB1ENR_TIM3EN))        //test hodin
      {
        RCC->APB1ENR |= RCC_APB1ENR_TIM3EN;
        RCC->APB1RSTR |= RCC_APB1RSTR_TIM3RST;
        RCC->APB1RSTR &= ~RCC_APB1RSTR_TIM3RST;
      }
      TIM3->CR1 = 0;             //DIR = 0 - up counter
      TIM3->CR2 = 0;             //zadne dalsi spec funkce
      TIM3->PSC = (apb1/255754) - 1;   // cca 255 kHz
      TIM3->ARR = 256 - 1;            // 1khz
      TIM3->CR1 = TIM_CR1_CEN;        // povoleni casovace
      Nucleo_SetPinGPIO(DRIVER_IN1A, ioPortAlternatePP);
      Nucleo_SetAFGPIO(DRIVER_IN1A, 2);   //AF02 odpovida TIM3_CH1
      Nucleo_SetPinGPIO(DRIVER_IN2A, ioPortAlternatePP);
      Nucleo_SetAFGPIO(DRIVER_IN2A, 2);   //AF02 odpovida TIM3_CH2
      //nastaveni channel 1
      TIM3->CCMR1 &= ~TIM_CCMR1_OC1CE;
      TIM3->CCMR1 |= TIM_CCMR1_OC1M_2 | TIM_CCMR1_OC1M_1;      //110 - PWM mode 1
      TIM3->CCER |= TIM_CCER_CC1E;
      TIM3->CCR1 = 0;   //strida

      //nastaveni channel 2
      TIM3->CCMR1 &= ~TIM_CCMR1_OC2CE;
      TIM3->CCMR1 |= TIM_CCMR1_OC2M_2 | TIM_CCMR1_OC2M_1;      //110 - PWM mode 1
      TIM3->CCER |= TIM_CCER_CC2E;
      TIM3->CCR2 = 0;   //strida

      // LEVY MOTOR B
      if(!(RCC->APB1ENR & RCC_APB1ENR_TIM5EN))        //test hodin
      {
        RCC->APB1ENR |= RCC_APB1ENR_TIM5EN;
        RCC->APB1RSTR |= RCC_APB1RSTR_TIM5RST;
        RCC->APB1RSTR &= ~RCC_APB1RSTR_TIM5RST;
      }
      TIM5->CR1 = 0;             //DIR = 0 - up counter
      TIM5->CR2 = 0;             //zadne dalsi spec funkce
      TIM5->PSC = (apb1/255754) - 1;   // cca 255 kHz
      TIM5->ARR = 256 - 1;            // 1khz
      TIM5->CR1 = TIM_CR1_CEN;        // povoleni casovace
      Nucleo_SetPinGPIO(DRIVER_IN1B, ioPortAlternatePP);
      Nucleo_SetAFGPIO(DRIVER_IN1B, 2);   //AF02 odpovida TIM5_CH1
      Nucleo_SetPinGPIO(DRIVER_IN2B, ioPortAlternatePP);
      Nucleo_SetAFGPIO(DRIVER_IN2B, 2);   //AF02 odpovida TIM5_CH2
      //nastaveni channel 1
      TIM5->CCMR1 &= ~TIM_CCMR1_OC1CE;
      TIM5->CCMR1 |= TIM_CCMR1_OC1M_2 | TIM_CCMR1_OC1M_1;      //110 - PWM mode 1
      TIM5->CCER |= TIM_CCER_CC1E;
      TIM5->CCR1 = 0;   //strida

      //nastaveni channel 2
      TIM5->CCMR1 &= ~TIM_CCMR1_OC2CE;
      TIM5->CCMR1 |= TIM_CCMR1_OC2M_2 | TIM_CCMR1_OC2M_1;      //110 - PWM mode 1
      TIM5->CCER |= TIM_CCER_CC2E;
      TIM5->CCR2 = 0;   //strida
      break;

    case pasak:
      // PRAVY MOTOR A
      if(!(RCC->APB1ENR & RCC_APB1ENR_TIM3EN))      //test hodin
      {
        RCC->APB1ENR |= RCC_APB1ENR_TIM3EN;
        RCC->APB1RSTR |= RCC_APB1RSTR_TIM3RST;
        RCC->APB1RSTR &= ~RCC_APB1RSTR_TIM3RST;
      }
      TIM3->CR1 = 0;             //DIR = 0 - up counter
      TIM3->CR2 = 0;             //zadne dalsi spec funkce
      TIM3->PSC = apb1/2040816 - 1;       // cca 2 MHz
      TIM3->ARR = 256 - 1;            // cca 8khz
      TIM3->CR1 = TIM_CR1_CEN;        // povoleni casovace

      Nucleo_SetPinGPIO(DRV8833_IN1A, ioPortAlternatePP);
      Nucleo_SetAFGPIO(DRV8833_IN1A, 2);   //AF02 odpovida TIM3_CH1
      Nucleo_SetPinGPIO(DRV8833_IN2A, ioPortAlternatePP);
      Nucleo_SetAFGPIO(DRV8833_IN2A, 2);   //AF02 odpovida TIM3_CH2
      //nastaveni channel 1
      TIM3->CCMR1 &= ~TIM_CCMR1_OC1CE;
      TIM3->CCMR1 |= TIM_CCMR1_OC1M_2 | TIM_CCMR1_OC1M_1;      //110 - PWM mode 1
      TIM3->CCER |= TIM_CCER_CC1E;
      TIM3->CCR1 = 0;   //strida

      //nastaveni channel 2
      TIM3->CCMR1 &= ~TIM_CCMR1_OC2CE;
      TIM3->CCMR1 |= TIM_CCMR1_OC2M_2 | TIM_CCMR1_OC2M_1;      //110 - PWM mode 1
      TIM3->CCER |= TIM_CCER_CC2E;
      TIM3->CCR2 = 0;   //strida

      // LEVY MOTOR B
      if(!(RCC->APB1ENR & RCC_APB1ENR_TIM5EN))    //test hodin
      {
        RCC->APB1ENR |= RCC_APB1ENR_TIM5EN;
        RCC->APB1RSTR |= RCC_APB1RSTR_TIM5RST;
        RCC->APB1RSTR &= ~RCC_APB1RSTR_TIM5RST;
      }
      TIM5->CR1 = 0;                  //DIR = 0 - up counter
      TIM5->CR2 = 0;                  //zadne dalsi spec funkce
      TIM5->PSC = (apb1/2040816) - 1;    // cca 2 MHz
      TIM5->ARR = 256 - 1;            // 8 khz
      TIM5->CR1 = TIM_CR1_CEN;        // povoleni casovace

      Nucleo_SetPinGPIO(DRV8833_IN1B, ioPortAlternatePP);
      Nucleo_SetAFGPIO(DRV8833_IN1B, 2);   //AF02 odpovida TIM5_CH1
      Nucleo_SetPinGPIO(DRV8833_IN2B, ioPortAlternatePP);
      Nucleo_SetAFGPIO(DRV8833_IN2B, 2);   //AF02 odpovida TIM5_CH2
      //nastaveni channel 1
      TIM5->CCMR1 &= ~TIM_CCMR1_OC1CE;
      TIM5->CCMR1 |= TIM_CCMR1_OC1M_2 | TIM_CCMR1_OC1M_1;      //110 - PWM mode 1
      TIM5->CCER |= TIM_CCER_CC1E;
      TIM5->CCR1 = 0;   //strida

      //nastaveni channel 2
      TIM5->CCMR1 &= ~TIM_CCMR1_OC2CE;
      TIM5->CCMR1 |= TIM_CCMR1_OC2M_2 | TIM_CCMR1_OC2M_1;      //110 - PWM mode 1
      TIM5->CCER |= TIM_CCER_CC2E;
      TIM5->CCR2 = 0;   //strida
      break;

    case kolovyPodvozek:
      Nucleo_SetPinGPIO(IHM12_REF,ioPortOutputPP);
      Nucleo_SetPinGPIO(IHM12_RESET, ioPortOutputPP);
      Nucleo_SetPinGPIO(IHM12_PHA, ioPortOutputPP);     //pin PHase jako vystupni
      Nucleo_SetPinGPIO(IHM12_PHB, ioPortOutputPP);     //pin PHase jako vystupni
      GPIOWrite(IHM12_REF, true);               //nastaveni reference do log 1
      GPIOWrite(IHM12_RESET,true);              //nastaveni resetu do log 1 == povoleno

      if(!(RCC->APB1ENR & RCC_APB1ENR_TIM3EN))  //test hodin
      {
        RCC->APB1ENR |= RCC_APB1ENR_TIM3EN;
        RCC->APB1RSTR |= RCC_APB1RSTR_TIM3RST;
        RCC->APB1RSTR &= ~RCC_APB1RSTR_TIM3RST;
      }
      TIM3->CR1 = 0;             //DIR = 0 - up counter
      TIM3->CR2 = 0;             //zadne dalsi spec funkce
      TIM3->PSC = (apb1/2040816) - 1;  // cca 2 MHz
      TIM3->ARR = 256 - 1;            // 8khz
      TIM3->CR1 = TIM_CR1_CEN;        // povoleni casovace

      // LEVY MOTOR B
      Nucleo_SetPinGPIO(IHM12_PWMB, ioPortAlternatePP);
      Nucleo_SetAFGPIO(IHM12_PWMB, 2);   //AF02 odpovida TIM3_CH2
      //nastaveni channel 2
      TIM3->CCMR1 &= ~TIM_CCMR1_OC2CE;
      TIM3->CCMR1 |= TIM_CCMR1_OC2M_2 | TIM_CCMR1_OC2M_1;      //110 - PWM mode 1
      TIM3->CCER |= TIM_CCER_CC2E;
      TIM3->CCR2 = 0;   //strida

      // RIGHT MOTOR A
      Nucleo_SetPinGPIO(IHM12_PWMA, ioPortAlternatePP);
      Nucleo_SetAFGPIO(IHM12_PWMA, 2);   //AF02 odpovida TIM3_CH1
      //nastaveni channel 1
      TIM3->CCMR1 &= ~TIM_CCMR1_OC1CE;
      TIM3->CCMR1 |= TIM_CCMR1_OC1M_2 | TIM_CCMR1_OC1M_1;      //110 - PWM mode 1
      TIM3->CCER |= TIM_CCER_CC1E;
      TIM3->CCR1 = 0;   //strida
      break;
    default:
      break;
  }
  return zvoleny;
}

void MotorsSetSpeed(int leftSpeed,int rightSpeed)
{
  if(leftSpeed >255 )
    leftSpeed=255;
  if(leftSpeed<-255)
    leftSpeed = -255;
  if(rightSpeed >255 )
    rightSpeed=255;
  if(rightSpeed<-255)
    rightSpeed = -255;
  uint8_t rightSpd = abs(rightSpeed);
  uint8_t leftSpd = abs(leftSpeed);
  switch(zvoleny)
  {
    case zumo:
      if(leftSpeed<0)                     //pokud je rychlost zaporna
      {
        GPIOWrite(ZUMO_M2DIR, true);      //nastavim smer vzad
      }
      else
      {
        GPIOWrite(ZUMO_M2DIR, false);     //jinak smer vpred
      }

      if(rightSpeed<0)                    //pokud je rychlost zaporna
      {
        GPIOWrite(ZUMO_M1DIR, true);      //nastavim smer vzad
      }
      else
      {
        GPIOWrite(ZUMO_M1DIR, false);     //jinak smer vpred
      }
      TIM4->CCR1 = leftSpd;               //nastaveni stridy PWM
      TIM3->CCR2 = rightSpd;              //nastaveni stridy PWM
      break;

    case lego:
      if(leftSpeed<0)                     //pokud je rychlost zaporna
      {
        TIM5->CCR1 = 0;                   //nastavim PWM na CH2 (smer vzad)
        TIM5->CCR2 = leftSpd;
      }
      else
      {
        TIM5->CCR1 = leftSpd;             //jinak nastavim PWM na CH1 (smer vpred)
        TIM5->CCR2 = 0;
      }

      if(rightSpeed<0)                    //pokud je rychlost zaporna
      {
        TIM3->CCR1 = 0;                   //nastavim PWM na CH2 (smer vzad)
        TIM3->CCR2 = rightSpd;
      }
      else
      {
        TIM3->CCR1 = rightSpd;            //jinak nastavim PWM na CH1 (smer vpred)
        TIM3->CCR2 = 0;
      }
      break;

    case pasak:                           //pokud je rychlost zaporna
      if(leftSpeed<0)
      {
        TIM3->CCR1 = 0;                   //nastavim PWM na CH2 (smer vzad)
        TIM3->CCR2 = leftSpd;
      }
      else
      {
        TIM3->CCR1 = leftSpd;             //jinak nastavim PWM na CH1 (smer vpred)
        TIM3->CCR2 = 0;
      }
      if(rightSpeed<0)                    //pokud je rychlost zaporna
      {
        TIM5->CCR1 = 0;                   //nastavim PWM na CH2 (smer vzad)
        TIM5->CCR2 = rightSpd;
      }
      else
      {
        TIM5->CCR1 = rightSpd;            //jinak nastavim PWM na CH1 (smer vpred)
        TIM5->CCR2 = 0;
      }
      break;

    case kolovyPodvozek:
      if(leftSpeed<0)                     //pokud je rychlost zaporna
      {
        GPIOWrite(IHM12_PHB, false);      //nastavim smer vzad
      }
      else
      {
        GPIOWrite(IHM12_PHB, true);       //jinak smer vpred
      }

      if(rightSpeed<0)                    //pokud je rychlost zaporna
      {
        GPIOWrite(IHM12_PHA, false);      //nastavim smer vzad
      }
      else
      {
        GPIOWrite(IHM12_PHA, true);       //jinak smer vpred
      }
      TIM3->CCR2 = leftSpd;               //nastaveni stridy PWM
      TIM3->CCR1 = rightSpd;              //nastaveni stridy PWM
      break;
    default:
      break;
  }
}




