/*
 * stm_core.h
 *
 *  Created on: 11. 2. 2021
 *      Author: tomas
 */

#ifndef STM_CORE_H_
#define STM_CORE_H_

#include "stm32f4xx.h"
#include <stdbool.h>
#include <stdio.h>

typedef enum {
  busClockAHB,
  busClockAPB1,
  busClockAPB2,
  timersClockAPB1,
  timersClockAPB2
} eBusClocks;

uint32_t GetBusClock(eBusClocks clk);

typedef enum {
  clockSourceHSI,
  clockSourceHSE
} eClockSources;

bool SetClock100MHz(eClockSources clkSrc);

bool SetClockHSI(void);

typedef enum {
  ioPortOutputPP,   // vystup Push-Pull
  ioPortOutputOC,   // vystup OpenColector
  ioPortAnalog,     // analogovy vstup - pro prevodnik
  ioPortInputFloat, // vstup bez PU/PD
  ioPortInputPU,    // vstup s pull-up
  ioPortInputPD,    // vstup s pull-down
  ioPortAlternatePP,// alternativni vystup - push/pull
  ioPortAlternateOC // alternativni vystup - open drain

}eIoPortModes;

bool Nucleo_SetPinGPIO(GPIO_TypeDef *gpio, uint32_t bitnum, eIoPortModes mode);
bool Nucleo_SetAFGPIO(GPIO_TypeDef *gpio, uint32_t bitnum, uint32_t afValue);
void GPIOToggle(GPIO_TypeDef *gpio, uint32_t bitnum);
bool GPIORead(GPIO_TypeDef *gpio, uint32_t bitnum);
void GPIOWrite(GPIO_TypeDef *gpio, uint32_t bitnum, bool state);

#define BOARD_BTN_BLUE  GPIOC, 13
#define BOARD_LED GPIOA, 5

#endif /* STM_CORE_H_ */
